#!/usr/bin/env python

from albatross import SimpleSessionApp, SessionAppContext
#from albatross import SimpleSessionFileApp, SessionFileAppContext
from albatross.cgiapp import Request


class Page1:
    name = 'Page1'
    def page_process(self, ctx):
        if ctx.req_equals('To_Page2') and \
                ctx.get_value('next_page') == 'Page2' and \
                ctx.get_value('user_name') != '' and \
                ctx.get_value('user_code') > '0':
            ctx.set_page('Page2')
        elif ctx.req_equals('To_Page3') and \
                ctx.get_value('next_page') == 'Page3':
            ctx.set_page('Page3')
        elif ctx.req_equals('To_thankyou') and \
                ctx.get_value('next_page') == 'thankyou':
            ctx.set_page('thankyou')

    def page_display(self, ctx):
        ctx.run_template('Page1.html')


class Page2:
    name = 'Page2'
    def page_process(self, ctx):
        if ctx.req_equals('To_Page3_'):
            ctx.set_page('Page3')
        elif ctx.req_equals('To_Page3_Page3') and \
                ctx.get_value('next_page') == 'Page3':
            ctx.set_page('Page3')
        elif ctx.req_equals('To_Page4') and \
                ctx.get_value('next_page') == 'Page4':
            ctx.set_page('Page4')
        elif ctx.req_equals('To_Page3'):
            ctx.set_page('Page3')

    def page_display(self, ctx):
        ctx.run_template('Page2.html')


class Page3:
    name = 'Page3'
    def page_process(self, ctx):
        if ctx.req_equals('To_Page4') and \
                ctx.get_value('next_page') == 'Page4':
            ctx.set_page('Page4')
        elif ctx.req_equals('To_Page1') and \
                ctx.get_value('next_page') == 'Page1':
            ctx.set_page('Page1')
        elif ctx.req_equals('To_Page5') and \
                ctx.get_value('next_page') == 'Page5':
            ctx.set_page('Page5')

    def page_display(self, ctx):
        ctx.run_template('Page3.html')


class Page4:
    name = 'Page4'
    def page_process(self, ctx):
        if ctx.req_equals('To_thankyou') and \
                ctx.get_value('next_page') == 'thankyou':
            ctx.set_page('thankyou')

    def page_display(self, ctx):
        ctx.run_template('Page4.html')


class Page5:
    name = 'Page5'
    def page_process(self, ctx):
        if ctx.req_equals('To_Page3') and \
                ctx.get_value('next_page') == 'Page3':
            ctx.set_page('Page3')

    def page_display(self, ctx):
        ctx.run_template('Page5.html')


class thankyou:
    name = 'thankyou'

    def page_display(self, ctx):
        ctx.run_template('thankyou.html')
        ctx.set_save_session(0)
        ctx.remove_session()


class AppContext(SessionAppContext):
    def __init__(self, app):
        SessionAppContext.__init__(self, app)


class App(SimpleSessionApp):
    def __init__(self):
        SimpleSessionApp.__init__(self,
            base_url = 'dispatch.py',
            template_path = '.',
            start_page = 'Page1',
            secret = 'finch',
            session_appid = 'app3')
            #session_dir= '/w2/Python/albatross-0.06/session-server/SessionData')
        for page_class in (Page1, Page2, Page3, Page4, Page5, thankyou, ):
            self.register_page(page_class.name, page_class())
    def create_context(self):
        return AppContext(self)


if __name__ == '__main__':
    app = App()
    app.run(Request())


